# Übungsaufgabe: Schemadefinition
## a) {-}
```sql
CREATE TABLE Person(
	PNr int NOT NULL,
	Vorname VARCHAR(50) NOT NULL,
	Nachname VARCHAR(50) NOT NULL,
	CONSTRAINT pk_PNr PRIMARY KEY (PNr)
);

CREATE TABLE Produzent(
	PNr int NOT NULL,
	GoldeneSchallplatten int NOT NULL,
	CONSTRAINT pk_PNr PRIMARY KEY (PNr),
	CONSTRAINT fk_PNr FOREIGN KEY (PNr) REFERENCES Person(PNr)
);

CREATE TABLE Musiker(
	PNr int NOT NULL,
	Stil VARCHAR(50) NOT NULL,
	# Bancmitglied?
	CONSTRAINT pk_PNr PRIMARY KEY (PNr),
	CONSTRAINT fk_PNr FOREIGN KEY (PNr) REFERENCES Person(PNr)
);

CREATE TABLE Manager(
	PNr int NOT NULL,
	Bueroadresse VARCHAR(100) NOT NULL, # eindeutig?
	#managt, leitet?
	CONSTRAINT pk_PNr PRIMARY KEY (PNr),
	CONSTRAINT fk_PNr FOREIGN KEY (PNr) REFERENCES Person(PNr)
);

CREATE TABLE Album(
	Name VARCHAR(50) NOT NULL,
	Releasedatum VARCHAR(8) NOT NULL,
	Preis int NOT NULL,
	Songs int NOT NULL,
	Laufzeit int NOT NULL,
	# Songs?
	CONSTRAINT pk_Name PRIMARY KEY (Name),
	CONSTRAINT Name >= 50,
);

CREATE TABLE Song(
	Songwriter int NOT NULL,
	Name VARCHAR(50) NOT NULL,
	Laufzeit int NOT NULL,
	Releasedatum VARCHAR(8) NOT NULL,
	Musikrichtung VARCHAR(50) NOT NULL,
	CONSTRAINT pk_Name PRIMARY KEY (Name),
	CONSTRAINT pk_songwriter PRIMARY KEY (Songwriter),
	CONSTRAINT fk_songwriter FOREIGN KEY (Songwriter) REFERENCES Band(Name),
);

CREATE TABLE Album_Song(
	Album VARCHAR(50) NOT NULL,
	Songwriter int NOT NULL,
	Song VARCHAR(50) NOT NULL,
	CONSTRAINT pk_album PRIMARY KEY (Album),
	CONSTRAINT pk_songwriter PRIMARY KEY (Songwriter),
	CONSTRAINT pk_song PRIMARY KEY (Song),
	CONSTRAINT fk_album FOREIGN KEY (Album) REFERENCES Album(Name),
	CONSTRAINT fk_songwriter FOREIGN KEY (Songwriter) REFERENCES Song(Songwriter),
	CONSTRAINT fk_song FOREIGN KEY (Song) REFERENCES Song(Name),
);

# TODO redundante Kommate entfernen