# Übungsaufgabe: Optimierung
## a) {-}
**Nicht Optimierter Baum:**
![Baum zu gegebenem Ausdruck](./images/operationtree.jpg)

**Optimierter Baum:**
![Optimierter Baum](./images/optimized_operationtree.jpg)

## b) {-}
**Nicht Optimierter Baum:**
Im Bild des nicht optimieten Baumes ist die Kardinalität der Zwischenergebnisse zu sehen. Es fällt auf, dass durch die Verwendung des Kreuzprodukts sowohl die Anzahl der Tupel als auch die der Attribute stark Steigt. Dadurch kommt es in dem Operationsbaum zwischenzeitlich zu einer Tupelanzahl von 40.000. Außerdem ist im unteren Teil des Baumes eine große Dopplung zu sehen. Diese Dopplung kommst zustande, indem zwei mal ein Eigentümer aus den Eigentümern rausgesucht wird. Hiernach wird mit beiden das Kreuzprodukt mit den Imobilen gebildet. Dadurch mussen gleich zu beginn zwei mal alle Eigentümer und Imobilien geladen werden.

**Optimierter Baum:**
Im optimietem Baum ist schnell zu erkennen, dass eine wesendlich kleinere Anzahl an Tupeln herscht. Dies kommt dadurch zustande, dass hier komplett auf Kreuzprodukte verzichtet worden ist. Die Kreuzprodukte wurden mit einigen Selectoren des obrigen Teils zu Verbunden zusammengefasst. Diese haben den Vorteil das bei der Zusammenfürung zweier Mengen eine geringere Zahl an Tupeln herforgebracht wird. Dies kommt dadurch zustannde, dass nur den Entetis, der Menge mit dem Fremdschlüsseln, die Enteties, der Menge mit dem Primärschlüssel, zugewiesen werden. Dadurch, dass nur Entetis mit einem Fremdschlüssel etwas zugewiesen bekommen können, kann die folgende Relation auch nicht größer sein als die Menge mit dem Fremdschlüssel. Das spart im Vergleich mit dem Kreuzprodukt einige Tupel ein.
Außerdem wurde der Doppelte zugriff auf sowohl Eigentümer als auch Imobilien zusammengefasst. Es ist also nicht mehr nötig Eigentümer und Imobilien doppelt laden zu müssen. Die höhste Anzahl von Tupeln ist 1000 welche nur ein mal beim Laden von Imobilien auftritt.
